﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using BroadcastModule;

namespace parkMonitor.server.broadcastModule
{
    public class BroadcastLinker
    {
        public static BroadcastBoard ins;
        static string ip;
        static int port;

        /// <summary>
        /// 初始化单例
        /// </summary>
        public static void Start()
        {
            Task.Factory.StartNew(() =>
            {
                try
                {
                    ip = ConfigurationManager.AppSettings["broadcastIP"];
                    port = Int32.Parse(ConfigurationManager.AppSettings["broadcastPort"]);
                    ins = new BroadcastBoard(ip, port);
                    ins.Refresh();
                    ins.AudioPlay("欢迎光临");
                    ins.DownloadString(0, "欢迎光临", 0);
                    ins.DownloadString(1, "智象停车", 0);
                    ins.DownloadString(2, "date", 0);
                    ins.DownloadString(3, "time", 0);
                    ins.DispDownStr(0, 0);
                    ins.DispDownStr(1, 0);
                    ins.DispDownStr(2, 0);
                    ins.DispDownStr(3, 0);
                }
                catch (Exception e) { Console.WriteLine(e.Message); ins = null; }
            });
        }

        public static void dispForAWhile(int winID, string str, int delay, bool switchToOrigin)
        {
            if (ins != null)
            {
                ins.DispString(winID, str, 10);
                Task.Factory.StartNew(() =>
                {
                    if (switchToOrigin)
                    {
                        Thread.Sleep(delay * 1000);
                        OriginState();
                    }
                });
            }
        }
        public static void OriginState()
        {
            if (ins != null)
            {
                ins.DispDownStr(0, 0);
                ins.DispDownStr(1, 0);
                ins.DispDownStr(2, 0);
                ins.DispDownStr(3, 0);
            }
        }
    }
}
