﻿using PLCS7;
using S7.Net;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace PLCTest
{
    class Program
    {
        static void Main(string[] args)
        {
            PLCLinker pl = new PLCLinker(CpuType.S71500, "192.168.0.1", 0, 1, 18, 41, 20, 1, 200);
            Random rnd = new Random();
            Task t = Task.Factory.StartNew(() =>
            {
                try
                {
                    while (true)
                    {
                        //parkingSpaceDBTest(pl, rnd);
                        terminalDBTest(pl, rnd);
                        //if (!pl.isConnected) { pl.PLCConnect(); }
                        //else
                        //{
                        //    //读终端块数据
                        //    List<object> tList = pl.ReadFromPLC(PLCDataType.terminal, 1);
                        //    foreach (var term in tList)
                        //    {
                        //        Console.WriteLine(((TerminalStru)term).ToString());
                        //    }
                        //    pl.WriteAccordingToOffset(PLCDataType.terminal, 6, (short)rnd.Next(1, 100));
                        //    pl.WriteAccordingToOffset(PLCDataType.terminal, 8, (short)rnd.Next(1, 100));
                        //    pl.WriteAccordingToOffset(PLCDataType.terminal, 10, (short)rnd.Next(1, 100));
                        //    pl.WriteAccordingToOffset(PLCDataType.terminal, 12, (short)rnd.Next(1, 100));
                        //    pl.WriteAccordingToOffset(PLCDataType.terminal, 14, (short)rnd.Next(1, 100));
                        //}
                        Thread.Sleep(500);
                    }
                }
                catch (Exception e) { Console.WriteLine("test:" + e.Message); }
            });
            t.Wait();

            //try
            //{
            //    TcpClient client = new TcpClient();
            //    client.Connect("www.baidu.com", 80);
            //    string ip = ((IPEndPoint)client.Client.LocalEndPoint).Address.ToString();
            //    client.Close();
            //    Console.WriteLine(ip.ToString());
            //}
            //catch (Exception e) { Console.WriteLine("wrong ipAddr"); }

            //Assembly assembly = Assembly.LoadFrom(AppDomain.CurrentDomain.BaseDirectory+"PLCS7.dll");
            //Type t = assembly.GetType("PLCS7.PLCLinker");
            //object[] constructorParams = new object[] { S7.Net.CpuType.S71500, "192.168.0.1", 0, 1, 18, 22, 20, 6, 200 };
            //if (t != null)
            //{
            //    //object instance = assembly.CreateInstance("PLCS7.PLCLinker",false,BindingFlags.CreateInstance,null,constructorParams,null,null);
            //    object instance = Activator.CreateInstance(t,constructorParams);
            //    AbstractPLCLinker plc = instance as AbstractPLCLinker;
            //    Console.WriteLine(plc.isConnected);
            //}
            Console.ReadLine();
        }
        public static void parkingSpaceDBTest(AbstractPLCLinker pl, Random rnd)
        {
            if (!pl.isConnected) { pl.PLCConnect(); }
            else
            {
                //读车位表信息
                List<object> psList = pl.ReadFromPLC(PLCDataType.parkingSpace, 1);
                psList.AddRange(pl.ReadFromPLC(PLCDataType.parkingSpace, 2));
                foreach (var ps in psList)
                {
                    Console.WriteLine(((ParkingSpaceStru)ps).ToString());
                }
                //写入车位状态信息
                ParkingSpaceStru pss = new ParkingSpaceStru
                {
                    parkingSpace = (short)rnd.Next(1, 3),
                    spaceStatus = (short)rnd.Next(0, 3)
                };
                pl.WriteToPLC(pss, PLCDataType.central);
                Console.WriteLine("写入状态值");
            }
        }

        public static void terminalDBTest(AbstractPLCLinker pl, Random rnd)
        {
            if (!pl.isConnected) { pl.PLCConnect(); }
            else
            {
                //读终端块数据
                List<object> tList = pl.ReadFromPLC(PLCDataType.terminal, 1);
                foreach (var term in tList)
                {
                    Console.WriteLine(((TerminalStru)term).ToString());
                }
                //模拟中控写数据
                TerminalStru tsCentral = new TerminalStru
                {
                    terminalID = 1,
                    paymentStatus = (short)rnd.Next(100, 999),
                    licVerification = -1,
                    parkingFee = (short)rnd.Next(100, 999),
                    userType = (short)rnd.Next(100, 999)
                };
                //模拟终端写数据
                TerminalStru tsTerminal = new TerminalStru
                {
                    terminalID = 1,
                    terminalStatus = (short)rnd.Next(100, 999),
                    btnStatus = (short)rnd.Next(100, 999),
                    licenseCodeA = (short)rnd.Next(100, 999),
                    licenseCodeB = -1,
                    licenseCodeC = (short)rnd.Next(100, 999),
                    receiptNum = (short)rnd.Next(100, 999)
                };
                Console.WriteLine(tsCentral);
                pl.WriteToPLC(tsCentral, PLCDataType.central);
                //pl.WriteToPLC(tsTerminal, PLCDataType.terminal);
            }
        }
    }
}
