using BroadcastModule;
using db;
using Monitor;
using MySql.Data.MySqlClient;
using NumMachine;
using parkMonitor.language;
using parkMonitor.model;
using PLCS7;
using System;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Management;
using System.Net;
using System.Threading;
using System.Threading.Tasks;
using WebServer;

namespace Monitor
{
    public class Monitor : IMonitor
    {
        /// <summary>
        /// ģ鵥
        /// </summary>
        public static Monitor ins { get; set; }
        /// <summary>
        /// пϵͳ״̬
        /// </summary>
        public static bool globalStatus = false;
        /// <summary>
        /// ʼ
        /// </summary>
        public static int initializeState = 0;
        /// <summary>
        /// PLC
        /// </summary>
        public static AbstractPLCLinker PLC = null;
        public static string plcIPAddr { get; set; }
        public static int plcRack { get; set; }
        public static int plcSlot { get; set; }
        public static string[] plcDatablockConfig { get; set; }
        public static int plcTerminalCount { get; set; }
        public static int plcParkingSpaceCount { get; set; }
        public static int plcRefreshInterval { get; set; }
        public static MainBlockStru mainBlockInfo { get; set; }
        public static List<ParkingSpaceStru> parkingSpaceInfo { get; set; }
        /// <summary>
        /// Զݿ
        /// </summary>
        public static DBOperation remoteDBOper;
        /// <summary>
        /// ݿ
        /// </summary>
        public static DBOperation localDBOper;
        /// <summary>
        /// ʾ
        /// </summary>
        public static BroadcastBoard allInOneMachine;
        public static string allInOneMachineIP { get; set; }
        public static int allInOneMachinePort { get; set; }
        /// <summary>
        /// ƻ
        /// </summary>
        public static INumMachineLinker numMachineLinker;
        public static IntPtr flpHandle;
        /// <summary>
        /// web
        /// </summary>
        public static IWebServer webServer;
        public static int webPort { get; set; }
        /// <summary>
        /// ϵͳʼ
        /// </summary>
        internal static SystemInitializer sysInitializer;
        /// <summary>
        /// ϵͳر״̬
        /// </summary>
        bool isClosing;
        /// <summary>
        /// ID
        /// </summary>
        public static int garageID;

        private void PLCUpdate()
        {
            while (!isClosing)
            {
                if (PLC != null && PLC.isConnected)
                {
                    List<object> received = PLC.ReadFromPLC(PLCDataType.terminal, 0);
                    //ȻȡնϢ
                    try
                    {
                        //նͬ
                        if (Terminal.Terminal.terminalInfo.Count == plcTerminalCount)
                        {
                            for (int i = 0; i < plcTerminalCount; i++)
                            {
                                //һ̸ֲ
                                if (!Terminal.Terminal.terminalInfo[i].Equals(received[i]))
                                {
                                    Terminal.Terminal.terminalInfo[i] = (TerminalStru)received[i];
                                }
                            }
                        }
                        else
                        {
                            //ʼնϢб
                            Terminal.Terminal.terminalInfo.Clear();
                            for (int i = 0; i < plcTerminalCount; i++)
                            {
                                Terminal.Terminal.terminalInfo.Add((TerminalStru)received[i]);
                                Terminal.Terminal.termUsedMap.Add(((TerminalStru)received[i]).terminalID, false);
                            }
                        }
                    }
                    catch (Exception e) { Console.WriteLine("PLCն," + e.Message); }
                    //ȡпؼϢ
                    try
                    {
                        received = PLC.ReadFromPLC(PLCDataType.central, 0);
                        if (received.Count > 0 && !mainBlockInfo.Equals(received[0]))
                        {
                            mainBlockInfo = (MainBlockStru)received[0];
                        }
                    }
                    catch (Exception e) { Console.WriteLine("PLCп," + e.Message); }
                    //гλϢ
                    try
                    {
                        received = PLC.ReadFromPLC(PLCDataType.parkingSpace, 0);
                        //Console.WriteLine(parkingSpaceInfo.Count+","+ plcParkingSpaceCount);
                        //λͬ
                        if (parkingSpaceInfo.Count == plcParkingSpaceCount)
                        {
                            for (int i = 0; i < plcParkingSpaceCount; i++)
                            {
                                //һ̸ֲ
                                if (!parkingSpaceInfo[i].Equals(received[i]))
                                {
                                    parkingSpaceInfo[i] = (ParkingSpaceStru)received[i];
                                }
                            }
                        }
                        else
                        {
                            parkingSpaceInfo.Clear();
                            for (int i = 0; i < plcParkingSpaceCount; i++)
                            {
                                parkingSpaceInfo.Add((ParkingSpaceStru)received[i]);
                            }
                        }
                    }
                    catch (Exception e) { Console.WriteLine("PLCسλ," + e.Message); }
                }
                Thread.Sleep(500);
            }
        }

        /// <summary>
        /// CPU
        /// </summary>
        /// <returns></returns>
        private static string getCPUName()
        {
            try
            {
                string str = string.Empty;
                ManagementClass mcCPU = new ManagementClass("Win32_Processor");
                ManagementObjectCollection mocCPU = mcCPU.GetInstances();
                foreach (ManagementObject m in mocCPU)
                {
                    string name = m["Name"].ToString();
                    return name;
                }
            }
            catch { }

            return "";
        }

        /// <summary>
        /// ϵͳ汾
        /// </summary>
        public static string getOsVersion()
        {
            string str = "Windows 10";
            try
            {
                string hdId = string.Empty;
                ManagementClass hardDisk = new ManagementClass("Win32_OperatingSystem");
                ManagementObjectCollection hardDiskC = hardDisk.GetInstances();
                foreach (ManagementObject m in hardDiskC)
                {
                    str = m["Name"].ToString().Split('|')[0].Replace("Microsoft", "").Trim();
                    break;
                }
            }
            catch
            {

            }
            return str;
        }

        /// <summary>
        /// Կ
        /// </summary>
        public static string getGPUName()
        {
            string result = "";
            try
            {

                ManagementClass hardDisk = new ManagementClass("Win32_VideoController");
                ManagementObjectCollection hardDiskC = hardDisk.GetInstances();
                foreach (ManagementObject m in hardDiskC)
                {
                    result = m["VideoProcessor"].ToString();
                    break;
                }
            }
            catch
            {

            }
            return result;
        }

        /// <summary>
        /// ȡϵͳڴС
        /// </summary>
        public static string getMenSize()
        {
            ManagementObjectSearcher searcher = new ManagementObjectSearcher();   //ڲѯһЩϵͳϢĹ 
            searcher.Query = new SelectQuery("Win32_PhysicalMemory", "", new string[] { "Capacity" });//òѯ 
            ManagementObjectCollection collection = searcher.Get();   //ȡڴ 
            ManagementObjectCollection.ManagementObjectEnumerator em = collection.GetEnumerator();

            long capacity = 0;
            while (em.MoveNext())
            {
                ManagementBaseObject baseObj = em.Current;
                if (baseObj.Properties["Capacity"].Value != null)
                {
                    try
                    {
                        capacity += long.Parse(baseObj.Properties["Capacity"].Value.ToString());
                    }
                    catch
                    {
                        return "-GB";
                    }
                }
            }
            int gb = 1024 * 1024 * 1024;
            return ((double)capacity / gb).ToString("0.0") + "GB";
        }

        //************************************ з **********************************
        public Monitor(IntPtr flpHandle)
        {
            Monitor.flpHandle = flpHandle;
            parkingSpaceInfo = new List<ParkingSpaceStru>();
            mainBlockInfo = new MainBlockStru();
        }

        public void DisplayPLCInfo()
        {

        }

        public void DisplayTerminalState()
        {

        }

        public void DisplayLicensePlate()
        {

        }

        public void DisplayImage()
        {

        }

        public static string GetSysInfo()
        {
            string info = "";
            Language lng = Language.ins;
            try
            {
                string endl = "\r\n";
                info += lng.autoPackSys + " " + lng.centralPort + endl + endl;
                info += lng.version + "" + SysConst.version() + endl + endl;

                info += lng.hostNmae + "" + Dns.GetHostName() + endl + endl;
                info += lng.os + "" + getOsVersion() + endl + endl;
                info += lng.cpu + "" + getCPUName() + endl + endl;
                info += lng.mem + "" + getMenSize() + endl + endl;
                info += lng.gpu + "" + getGPUName() + endl + endl;
            }
            catch (Exception) { }
            return info;
        }

        public static List<object[]> GetParkingRecords()
        {
            DateTime now = DateTime.Now;
            DateTime yesterday = DateTime.Now - (new TimeSpan(1, 0, 0, 0));
            DateTime twoDaysAgo = DateTime.Now - (new TimeSpan(2, 0, 0, 0));
            List<object[]> result = new List<object[]>();
            string getParkingRecordsSql = "select parkingRecordsID,userID,numberPlate,parkingSpaceID,realParkTime,realGetTime,receiptNum,parkingPrice from parkingrecords where realParkTime like '" + yesterday.ToString("yyyy-MM-dd") + "' or '" + now.ToString("yyyy-MM-dd") + "' or '" + twoDaysAgo.ToString("yyyy-MM-dd") + "';";
            //MySqlDataReader reader = localDBOper.Query(getParkingRecordsSql);
            lock (localDBOper)
            {
                try
                {
                    MySqlDataAdapter adapter = localDBOper.Display(getParkingRecordsSql);
                    DataSet ds = new DataSet();
                    adapter.Fill(ds);
                    DataTable dt = ds.Tables[0];
                    for (int i = 0; i < dt.Rows.Count; i++)
                    {
                        object[] objArray = new object[10];
                        for (int j = 0; j < dt.Columns.Count; j++)
                        {
                            objArray[j] = dt.Rows[i][j];
                        }
                        result.Add(objArray);
                    }
                    adapter.Dispose();
                }
                catch (Exception e) { Console.WriteLine(e.Message); }
            }
            //while (reader != null && reader.Read())
            //{
            //    if (reader.HasRows)
            //    {
            //        object[] temp = new object[reader.FieldCount];
            //        reader.GetValues(temp);
            //        result.Add(temp);
            //    }
            //}
            //try
            //{
            //    if (reader != null)
            //    {
            //        reader.Close();
            //        reader.Dispose();
            //    }
            //}
            //catch { }
            result.Reverse();
            return result;
        }

        public static List<object[]> GetOrderRecords()
        {
            return null;
        }

        public void Start()
        {
            if (flpHandle != IntPtr.Zero)
            {
                //ʼϵͳ
                if (sysInitializer == null)
                {
                    sysInitializer = new SystemInitializer();
                }
                Task.Factory.StartNew(() =>
                {
                    sysInitializer.Init(flpHandle);
                });

                //PLC
                Task.Factory.StartNew(() =>
                {
                    PLCUpdate();
                });
            }
        }

        public void Stop()
        {
            sysInitializer.Stop();
        }
    }

    //public class ParkingRecord
    //{
    //    int parkingRecordsID;
    //    int userID;
    //    string numberPlate;
    //    int parkingSpaceID;

    //}
}

